if string.lower(RequiredScript) == "lib/managers/localizationmanager" then
	_G.LVLUP = _G.LVLUP or {}
	LVLUP._mod_path = LVLUP._mod_path or ModPath
	LVLUP._setting_path = ModPath .. "save.json"
	LVLUP.settings = LVLUP.settings or {}
	LVLUP.stingers = {
		"stinger_feedback_positive",
		"chill_upgrade_stinger",
		"stinger_levelup",
		"infamous_stinger_generic",
		"sidejob_stinger_long",
		"sidejob_stinger_short"
	}
	function LVLUP:Save()
		local file = io.open(self._setting_path, "w+")
		if file then
			file:write(json.encode(self.settings))
			file:close()
		end
	end

	function LVLUP:Load()
		local file = io.open(self._setting_path, "r")
		if file then
			for k, v in pairs(json.decode(file:read("*all")) or {}) do
				self.settings[k] = v
			end
			file:close()
		else
			self.settings = {
				levelup_stinger = 1
			}
			self:Save()
		end
	end
					
	Hooks:Add("MenuManagerInitialize", "MenuManagerInitialize_LVLUP", function(...)
		LVLUP:Load()
		
		MenuCallbackHandler.choose_stinger_callback = function(self, item)
			LVLUP.settings.levelup_stinger = tonumber(item:value()) or 1
			LVLUP:Save()
			managers.menu:post_event(LVLUP.stingers[LVLUP.settings.levelup_stinger])
		end
		
		MenuHelper:LoadFromJsonFile(LVLUP._mod_path .. "options.json", LVLUP, LVLUP.settings)
	end)

	Hooks:Add("LocalizationManagerPostInit", "LVLUP_popup_loc", function(...)		
		LocalizationManager:add_localized_strings({
			menu_LVLUP_name = "LEVEL UP Message",
			menu_reached_level_title = "Level Up!",
			menu_reached_level_desc = "Reputation Level Reached",
			menu_current_potential_levelup = "Reputation Level Reached:   $CURRENT_LVLUP",
			LVLUP_choose_stinger_title = "Level Up Stinger",
			LVLUP_choose_stinger_desc = "Select Level Up Stinger",
			stinger_feedback_positive = "Default",
			chill_upgrade_stinger = "Aldstone",
			stinger_levelup = "Level Up",
			infamous_stinger_generic = "Infamy",
			sidejob_stinger_long = "Side Job (Long)",
			sidejob_stinger_short = "Side Job (Short)",
		})
		
		if Idstring("russian"):key() == SystemInfo:language():key() then
			LocalizationManager:add_localized_strings({
				menu_reached_level_title = "Уровень получен!",
				menu_reached_level_desc = "Достигнут уровень",
				menu_current_potential_levelup = "Достигнут уровень репутации:   $CURRENT_LVLUP",
				LVLUP_choose_stinger_title = "Звук",
				LVLUP_choose_stinger_desc = "Выбрать звук повышения уровня",
				stinger_feedback_positive = "По умолчанию",
			})
		end
	end)
end
local Void_UI = VoidUI and VoidUI.loaded
local Custom_HUDs = Void_UI
if string.lower(RequiredScript) == "lib/managers/hud/hudchallengenotification" then
	local data = HudChallengeNotification.init
	function HudChallengeNotification:init(title, text, icon, rewards, queue)
		data(self, title, text, icon, rewards, queue)
		if not Custom_HUDs then
			if icon == "level_up_icon" then
				local box = ExtendedPanel:new(self)
				
				box:set_y(20)
				local size = 68
				local player_level_panel = box:panel({
					vertical = "center",
					align = "center",
					name = "player_level_panel",
					y = 10,
					x = 10,
					w = size,
					h = size
				})
				local function exp_ring(color)
					local exp_ring = player_level_panel:bitmap({
						texture = "guis/textures/pd2/endscreen/exp_ring",
						alpha = 0.4,
						texture_rect = {
							16,
							16,
							224,
							224
						},
						w = size,
						h = size,
						color = Color.white
					})
					if color then
						exp_ring:set_alpha(1)
						exp_ring:set_render_template(Idstring("VertexColorTexturedRadial"))
						exp_ring:set_color(color)
					end
				end
				
				exp_ring(Color(text * 0.01, 1, 1))
				exp_ring()
				
				player_level_panel:text({
					vertical = "center",
					align = "center",
					y = 2,
					text = tostring(text),
					font = tweak_data.menu.pd2_massive_font,
					font_size = 29
				})
				local desc = box:text({
					vertical = "center",
					text = managers.localization:to_upper_text("menu_reached_level_desc"),
					font = tweak_data.menu.pd2_medium_font,
					font_size = tweak_data.menu.pd2_medium_font_size,
					y = -10
				})
				desc:set_left(player_level_panel:right() + 10)
			end
		end
	end
	
	Hooks:PostHook(HudChallengeNotification, "close", "LVLUP_play_jingle_again", function()
		managers.experience._message_is_active = false
	end)
end
if string.lower(RequiredScript) == "lib/managers/experiencemanager" then
	Hooks:PostHook(ExperienceManager, "init", "initial_thingies", function(self)
		self._message_is_active = false
	end)

	local level = 0
	Hooks:PostHook(ExperienceManager, "mission_xp_award", "LVLUP_show_message", function(self, amount)
		local total = managers.experience:get_xp_dissected(true, managers.network:session():amount_of_alive_players() or 0, not Utils:IsInCustody())
		local level_ups = math.floor(managers.experience:get_levels_gained_from_xp(total))
		
		tweak_data.hud_icons.level_up_icon = {
			texture = "guis/textures/pd2/blackmarket/xp_drop",
			texture_rect = Custom_HUDs and {0, 0, 128, 128} or {128, 128, 128, 128}
		}
		
		if Custom_HUDs then
			local icon = tweak_data.hud_icons
			if level_ups == 5 then
				icon.level_up_icon = icon.Other_H_All_AllLevel005
			elseif level_ups == 10 then
				icon.level_up_icon = icon.Other_H_All_AllLevel010
			elseif level_ups == 25 then
				icon.level_up_icon = icon.Other_H_All_AllLevel025
			elseif level_ups == 50 then
				icon.level_up_icon = icon.Other_H_All_AllLevel050
			elseif level_ups == 75 then
				icon.level_up_icon = icon.Other_H_All_AllLevel075
			elseif level_ups == 100 then
				icon.level_up_icon = icon.Other_H_All_AllLevel100
			end
		end
		
		local potential_level = managers.experience:current_level() + level_ups
		if managers.hud then
			if level < level_ups and potential_level <= managers.experience:level_cap() then
				local text = Custom_HUDs and managers.localization:to_upper_text("menu_current_potential_levelup", {CURRENT_LVLUP = potential_level}) or potential_level
				managers.hud:custom_ingame_popup_text(
					managers.localization:to_upper_text("menu_reached_level_title"),
					text,
					"level_up_icon"
				)
				if not self._message_is_active then
					managers.menu:post_event(LVLUP.stingers[LVLUP.settings.levelup_stinger])
					self._message_is_active = true
				end
			end
		end
		
		level = level_ups
	end)
end